subroutine cluster(NOday, clusterNo, maxcls, Clfreq, clprob,cldays,idum)

implicit none

Integer, INTENT(IN) :: Noday
Integer, INTENT(IN) :: clusterNo,maxcls
REAL, INTENT(IN),DIMENSION(maxcls) :: clfreq
REAL, INTENT(IN),DIMENSION(maxcls,maxcls) :: clprob
Integer, INTENT(OUT),DIMENSION(maxcls) :: cldays
Integer, INTENT(INOUT)::idum
Integer,allocatable :: daycls(:)

Integer :: i,i1,n1,n2,n3
REAL :: rand11

ALLOCATE(daycls(NODay))

Do i=1, NOday

	if(i==1) then 
		call randomr1(rand11,idum)
		DO i1=1,clusterNo
			if(Clfreq(i1)>=rand11) then
				daycls(i)=i1
!				write(*,*) rand11,clfreq(i1),i1
				exit
			end if
		end do
	end if

	if(i>1) then

		if(daycls(i-1)==1) then
			call randomr1(rand11,idum)
			do n1=1,clusterNo
				if(clprob(1,n1)>=rand11) then
					daycls(i)=n1
					exit
				end if
			end do
		end if


		if(daycls(i-1)==2) then
			call randomr1(rand11,idum)
			do n2=1,clusterNo
				if(clprob(2,n2)>=rand11) then
					daycls(i)=n2
					exit
				end if
			end do
		end if

		if(daycls(i-1)==3) then
			call randomr1(rand11,idum)
			do n3=1,clusterNo
				if(clprob(3,n3)>=rand11) then
					daycls(i)=n3
					exit
				end if
			end do				
		end if
	end if
!	write(*,*) i,daycls(i),NOday
end do

!write(*,*)'end of loop'
cldays=0

Do i=1, NOday

	if(daycls(i)==1) then
		cldays(1)=cldays(1)+1
	end if
	
	if(daycls(i)==2) then
		cldays(2)=cldays(2)+1
	end if

	if(daycls(i)==3) then
		cldays(3)=cldays(3)+1
	end if

!	write(*,*)'finish1'

end do

END Subroutine cluster
	
function ran2(idum)
!
     IMPLICIT NONE
     INTEGER, PARAMETER :: ntab=32,ia=16807,im=2147483647,iq=127773,ir=2836
     REAL, PARAMETER :: eps=1.2e-7
     INTEGER :: idum,ndiv=(1+(im-1)/ntab),j,k
     REAL    :: ran2, am=(1.0/im), rnmx=(1.0-eps)
     SAVE iv, iy
     INTEGER :: iv(ntab)=0, iy=0
!
     if (idum <= 0 .or. iy == 0.0) then
       idum = max(-idum,1)
       do 11 j = ntab+8,1,-1
          k = idum/iq
          idum = ia*(idum-k*iq)-ir*k
          if (idum < 0) idum = idum +im
          if (j <= ntab) iv(j) = idum
 11    continue
       iy = iv(1)
     end if
     k = idum/iq
     idum = ia*(idum-k*iq)-ir*k
     if (idum < 0) idum = idum+im
     j = 1+iy/ndiv
     iy = iv(j)
     iv(j) = idum
     ran2 = min(am*iy,rnmx)
     return
end function ran2
!
SUBROUTINE randomr1 (arand,idum)
!
! This program will generate a random number ranging from
! ??? and ???. The program is adopted from Press et al.(1992,pp.271)
!
! Declarations
!
IMPLICIT NONE
INTEGER :: i
REAL    :: ran2
REAL, INTENT(OUT) :: arand
INTEGER, INTENT(IN OUT) :: idum
!
arand = 0.0
!
arand= ran2(idum)
!
END SUBROUTINE randomr1	